diff --git a/books/bookvol9.pamphlet b/books/bookvol9.pamphlet
index 7f369e1..e9553e1 100644
--- a/books/bookvol9.pamphlet
+++ b/books/bookvol9.pamphlet
@@ -19564,6 +19564,25 @@ deleting entries from u assumes that the first element is useless
 
 \end{chunk}
 
+\defun{checkAddIndented}{checkAddIndented}
+\calls{checkAddIndented}{firstNonBlankPosition}
+\calls{checkAddIndented}{strconc}
+\calls{checkAddIndented}{stringimage}
+\calls{checkAddIndented}{checkAddSpaceSegments}
+\tpdhere{Note that this function was missing without error, so may be junk}
+\begin{chunk}{defun checkAddIndented}
+(defun |checkAddIndented| (x margin)
+ (let (k)
+  (setq k (|firstNonBlankPosition| x))
+  (cond
+    ((eql k -1) "\\blankline ")
+    ((eql margin k) x)
+    (t
+     (strconc "\\indented{" (stringimage (- k margin)) "}{"
+      (|checkAddSpaceSegments| (substring x k nil) 0) "}")))))
+
+\end{chunk}
+
 \defun{checkRecordHash}{checkRecordHash}
 \calls{checkRecordHash}{member}
 \calls{checkRecordHash}{checkLookForLeftBrace}
@@ -20817,6 +20836,7 @@ A nil return implies that the argument list length does not match
 \defun{checkIndentedLines}{checkIndentedLines}
 \calls{checkIndentedLines}{firstNonBlankPosition}
 \calls{checkIndentedLines}{strconc}
+\calls{checkIndentedLines}{checkAddSpaceSegments}
 \refsdollar{checkIndentedLines}{charFauxNewline}
 \begin{chunk}{defun checkIndentedLines}
 (defun |checkIndentedLines| (u margin)
@@ -25240,6 +25260,7 @@ The current input line.
 \getchunk{defun checkSkipIdentifierToken}
 \getchunk{defun checkSkipOpToken}
 \getchunk{defun checkSkipToken}
+\getchunk{defun checkAddIndented}
 \getchunk{defun checkAddSpaces}
 \getchunk{defun checkSplitBackslash}
 \getchunk{defun checkSplitBrace}
diff --git a/changelog b/changelog
index 57856df..8edcce1 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,5 @@
+20111208 tpd src/axiom-website/patches.html 20111208.04.tpd.patch
+20111208 tpd books/bookvol9 code cleanup
 20111208 tpd src/axiom-website/patches.html 20111208.03.tpd.patch
 20111208 tpd src/interp/i-funsel.lisp treeshake interpreter
 20111208 tpd books/bookvol5 treeshake interpreter
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index 8d29af9..57e0f15 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -3731,5 +3731,7 @@ books/bookvolbib add additional Axiom literature references<br/>
 src/axiom-website/documentation update contributor list<br/>
 <a href="patches/20111208.03.tpd.patch">20111208.03.tpd.patch</a>
 books/bookvol5 treeshake interpreter<br/>
+<a href="patches/20111208.04.tpd.patch">20111208.04.tpd.patch</a>
+books/bookvol9 code cleanup<br/>
  </body>
 </html>
